This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 829708 - Review Request: clojure-compat - A dynamic programming language that targets the Java Virtual Machine
Review Request: clojure-compat - A dynamic programming language that targets ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michel Alexandre Salim
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 830714
  Show dependency treegraph
 
Reported: 2012-06-07 07:26 EDT by kushaldas@gmail.com
Modified: 2012-06-30 18:03 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-06-30 18:03:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
michel: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description kushaldas@gmail.com 2012-06-07 07:26:40 EDT
Spec URL: http://kushal.fedorapeople.org/packages/clojure-compat.spec
SRPM URL: http://kushal.fedorapeople.org/packages/clojure-compat-1.2.1-1.el6.src.rpm
Description: Clojure is a dynamic programming language that targets the Java
Virtual Machine. It is designed to be a general-purpose language,
combining the approachability and interactive development of a
scripting language with an efficient and robust infrastructure for
multithreaded programming. Clojure is a compiled language - it
compiles directly to JVM bytecode, yet remains completely
dynamic. Every feature supported by Clojure is supported at
runtime. Clojure provides easy access to the Java frameworks, with
optional type hints and type inference, to ensure that calls to Java
can avoid reflection.
Fedora Account System Username: kushal
Comment 1 Michel Alexandre Salim 2012-06-07 07:32:21 EDT
Taking this review
Comment 2 kushaldas@gmail.com 2012-06-07 08:39:11 EDT
Correct link to the srpm: http://kushal.fedorapeople.org/packages/clojure-compat-1.2.1-1.fc17.src.rpm
Comment 3 Michel Alexandre Salim 2012-06-07 09:08:15 EDT
Annotation tests for "java 6 and later" seem to fail on Java 7, but are fine on Java 6 (as in RHEL 6). Let's just quickly get rid of it -- in %prep:

# Java 6 annotation tests fail on Java 7
cp -f test/clojure/test_clojure/annotations/java_{5,6_and_later}.clj

also, fix the download URL in the comment (the clojure- prefix shouldn't be there for 1.2.1) and prune the changelog and indicate which version of the original clojure package this spec is based on (1:1-4.0-2) and I'll do the full review.

Thanks!
Comment 4 Michel Alexandre Salim 2012-06-07 09:10:08 EDT
Oops, the hack in %prep should of course only be run on Fedora (F-16 also has OpenJDK 7) -- either use %if 0%{?fedora} or %if ! 0%{?rhel}
Comment 6 Michel Alexandre Salim 2012-06-07 13:32:46 EDT
Full review below. We are targeting EPEL so I think the %clean section is fine -- though the guideline confusingly no longer says it is required for EPEL 6; would be nice to know (in the future) what's the actual situation.

Please add a runtime dependency on jpackage-utils when importing for directory ownership - right now we get that through objectweb-asm but that's a bit iffy.

APPROVED

Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[-]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[!]: MUST Package requires other packages for directories it uses.
     Need to require jpackage-utils
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
     Note: Could not retrieve sources. Please check the source files for
     licenses manually.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint output is silent.
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
Package has no sources or they are generated by developer
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[-]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
     (latest 1.2 release needed for Leiningen 1.x)
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
     checks run as part of the default ant target
[-]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
See: http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean
[!]: MUST Package requires other packages for directories it uses.
     Need to require jpackage-utils


Generated by fedora-review 0.2.0git
External plugins:
Comment 7 kushaldas@gmail.com 2012-06-07 13:56:14 EDT
New Package SCM Request
=======================
Package Name: clojure-compat
Short Description: A dynamic programming language that targets the Java Virtual Machine
Owners: kushal
Branches: f17 f16 el6
InitialCC: kushal salimma
Comment 8 Jon Ciesla 2012-06-07 14:05:51 EDT
Git done (by process-git-requests).
Comment 9 Fedora Update System 2012-06-08 02:00:33 EDT
clojure-compat-1.2.1-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/clojure-compat-1.2.1-2.fc17
Comment 10 Fedora Update System 2012-06-08 20:01:22 EDT
clojure-compat-1.2.1-2.fc17 has been pushed to the Fedora 17 testing repository.
Comment 11 Fedora Update System 2012-06-30 18:03:57 EDT
clojure-compat-1.2.1-2.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.